C
      SUBROUTINE DATAGN
C     DATAGN IS THE MAIN ROUTINE FOR INPUT OF GEOMETRY DATA.
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      CHARACTER*2 GM,GMJ
      CHARACTER*78 COMMENT
      INCLUDE 'data.inc'
      INCLUDE 'cntrl.inc'
      INCLUDE 'minim.inc'
      COMMON  /ANGL/ SALP( NM)
      DIMENSION X2(NM),Y2(NM),XZ2(NM),T1X(NM),T1Y(NM),T1Z(NM),T2X(NM),
     &T2Y(NM), T2Z(NM), CAB(NM), SAB(NM)
      EQUIVALENCE(T1X,SI),(T1Y,ALP),(T1Z,BET),(T2X,ICON1),(T2Y,ICON2),(
     &T2Z,ITAG),(X2,SI),(Y2,ALP),(XZ2,BET),(CAB,ALP),(SAB,BET)
      DATA   TA/0.01745329252D+0/, TD/57.29577951D+0/
      IPSYM=0
      NWIRE=0
      N=0
      NP=0
C First read comment lines (any number of them)
      IF(IOUT.NE.0)GOTO 2
      OPEN ( UNIT=26,FILE='OUTPUT.NEC')
      REWIND 26
   2  READ( 5,125)  GM,COMMENT
  125 FORMAT(A2,A77)
      IF(IOUT.EQ.0)WRITE(26,125)  GM,COMMENT
      CALL STR0PC( GM)
      IF( GM.EQ.'CM') GOTO 2
      IF( GM.EQ.'CE') GOTO 4
      WRITE(*,*)'Incorrect input, comment lines. Option:',GM
      STOP
    4 CONTINUE


C Read PARNR.NEC to get NEC2 modifications (if any).
      CALL READGM(GMJ,JTG,NNS,PX1,PY1,PZ1,PX2,PY2,PZ2,PRD,7)
      IF(GMJ.NE.'MO')GOTO 2005
      IRADCO=JTG
      CVEL=299.729458D0
      IF(IRADCO.EQ.0)CVEL=299.8
      FBEGIN= CVEL
      CALL READGM(GMJ,JTG,NNS,PX1,PY1,PZ1,PX2,PY2,PZ2,PRD,7)
      IF(GMJ.NE.'GS')GOTO 2005
      GSVAL=PX1
      CALL READMN(GMJ,ITMP1,ITMP2,ITMP3,ITMP4,TMP1,TMP2,TMP3,
     &TMP4,TMP5,TMP6,7)
      IF(GMJ.NE.'FR')GOTO 2005
      IFRQ= ITMP1
      NFRQ= ITMP2
      IF( NFRQ.EQ.0) NFRQ=1
      DELFRQ=1
      IF( IFRQ.EQ.1) GOTO 7843
      FBEGIN= TMP1
      DELFRQ= TMP2
      FMHZ= FBEGIN + NOWFRQ*DELFRQ
      GOTO 7844
 7843 FMHZ= FBEGIN * DELFRQ**NOWFRQ
 7844 WLAM= CVEL/ FMHZ

C
C     READ GEOMETRY DATA CARD AND BRANCH TO SECTION FOR OPERATION
C     REQUESTED
    1 CALL READGM(GM,ITG,NS,XW1,YW1,XZW1,XW2,YW2,XZW2,RAD,5)
      IF(N.GT.NM) GOTO 37
      IF(GM.EQ.'GW') GOTO 3
      IF(GM.EQ.'GX') GOTO 18
      IF(GM.EQ.'GR') GOTO 19
      IF(GM.EQ.'GS') GOTO 21
      IF(GM.EQ.'GE') GOTO 29
      IF(GM.EQ.'GM') GOTO 26
      IF(GM.EQ.'GA') GOTO 8
      IF(GM.EQ.'GH') GOTO 123
      WRITE(*,*)(' GEOMETRY DATA CARD ERROR (or option not supported)')
      WRITE(*,49)  GM, ITG, NS, XW1, YW1, XZW1,XW2, YW2, XZW2, RAD
   49 FORMAT(1X,A2,I3,I5,7F10.5)
      STOP
C
C *GW* Generate straight wire
    3 IWIR=1

   38 NWIRE= NWIRE+1
      I1= N+1
      I2= N+ NS

c      if(rad.le.4)then
c      yw1=yw1+0.8
c      yw2=yw2-0.8
c      endif
c      WRITE(*,43)  NWIRE, XW1, YW1, XZW1,XW2,YW2,XZW2,RAD, NS, I1,
c     &I2, ITG
c   43 FORMAT(I4,3F9.2,1X,3F9.2,F6.2,I4,I4,I4,I3)


      IF(IWIR.EQ.0.OR.RAD.NE.0) GOTO 7
      WRITE(*,*)'Radius=0 - GC option not allowed - no tapering'
      STOP
C Read PARNR.NEC and adjust if current NPAR found.
    7 CALL READGM(GMJ,JTG,NNS,PX1,PY1,PZ1,PX2,PY2,PZ2,PRD,7)
      IF(IWIR.EQ.1.AND.GMJ.NE.'GW')GOTO 2105
      IF(IWIR.EQ.0.AND.GMJ.NE.'GA')GOTO 2105
      IF(JTG.NE.ITG)GOTO 2105
      IX1=ABS(PX1)
      IY1=ABS(PY1)
      IZ1=ABS(PZ1)
      IX2=ABS(PX2)
      IY2=ABS(PY2)
      IZ2=ABS(PZ2)
      IRD=PRD
      IF(NPAR.EQ.0)GOTO 2010
 2030 CONTINUE
      IF(IX1.NE.0)XW1=XW1+WLAM*PAR(IX1)*PX1/IX1
      IF(IY1.NE.0)YW1=YW1+WLAM*PAR(IY1)*PY1/IY1
      IF(IZ1.NE.0)XZW1=XZW1+WLAM*PAR(IZ1)*PZ1/IZ1
      IF(IX2.NE.0)XW2=XW2+WLAM*PAR(IX2)*PX2/IX2
      IF(IY2.NE.0)YW2=YW2+WLAM*PAR(IY2)*PY2/IY2
      IF(IZ2.NE.0)XZW2=XZW2+WLAM*PAR(IZ2)*PZ2/IZ2
      IF(IOUT.EQ.0)WRITE(26,430)GM,ITG,NS,XW1,YW1,XZW1,
     & XW2,YW2,XZW2,RAD
 430  FORMAT(A2,I3,I5,6F10.3,F9.3)
      IF(IWIR.EQ.0)GOTO 818
      CALL WIRE( XW1, YW1, XZW1, XW2, YW2, XZW2, RAD, NS, ITG)
      GOTO 1
 2010 IF(NNPAR.LT.IX1)NNPAR=IX1
      IF(NNPAR.LT.IY1)NNPAR=IY1
      IF(NNPAR.LT.IZ1)NNPAR=IZ1
      IF(NNPAR.LT.IX2)NNPAR=IX2
      IF(NNPAR.LT.IY2)NNPAR=IY2
      IF(NNPAR.LT.IZ2)NNPAR=IZ2
      IF(NNPAR.LT.IRD)NNPAR=IRD
      GOTO 2030
 2105 WRITE(*,49)GM, ITG, NS, XW1, YW1, XZW1,XW2, YW2, XZW2, RAD
 2005 WRITE(*,*)'ERROR IN PARNR.NEC'
      WRITE(*,49)GMJ,JTG,NNS,PX1,PY1,PZ1,PX2,PY2,PZ2,PRD
      STOP

C
C *GA* Generate wire arc.
    8 IWIR=0
C      WRITE(*,38)  NWIRE, XW1, YW1, XZW1,XW2,NS, I1, I2, ITG
C   38 FORMAT(I4,'ARC RADIUS=',F9.5,2X,'FROM',F8.3,' TO',F8.3,
C     &' DEGREES',F8.2,I4,I4,I4,I3)
      GOTO 38
  818 CALL ARC( ITG, NS, XW1, YW1, XZW1, XW2)
      GOTO 1

C *GM* Move or copy structure to new position
   26 CONTINUE
c      IF(IOUT.EQ.0)WRITE(26,430)GM,ITG,NS,XW1,YW1,XZW1,
c     & XW2,YW2,XZW2,RAD
C      WRITE(*,47)  ITG, NS, XW1, YW1, XZW1, XW2, YW2, XZW2, RAD
C   47 FORMAT(' THE STRUCTURE HAS BEEN MOVED, MOVE DATA CARD IS',/,
C     &I4,I5,7F10.4)
C Read PARNR.NEC and adjust if current NPAR found.
      CALL READGM(GMJ,JTG,NNS,PX1,PY1,PZ1,PX2,PY2,PZ2,PRD,7)
      IMOV=INT(RAD+.5)
      IF(IMOV.NE.INT(PRD+.5))GOTO 2105
      IF(GMJ.NE.'GM')GOTO 2105
      IF(JTG.NE.ITG)GOTO 2105
      IX1=ABS(PX1)
      IY1=ABS(PY1)
      IZ1=ABS(PZ1)
      IX2=ABS(PX2)
      IY2=ABS(PY2)
      IZ2=ABS(PZ2)
      IRD=PRD
      IF(NPAR.EQ.0)GOTO 2210
 2230 CONTINUE
      IF(IX1.NE.0)XW1=XW1+WLAM*PAR(IX1)*PX1/IX1
      IF(IY1.NE.0)YW1=YW1+WLAM*PAR(IY1)*PY1/IY1
      IF(IZ1.NE.0)XZW1=XZW1+WLAM*PAR(IZ1)*PZ1/IZ1
      IF(IX2.NE.0)XW2=XW2+WLAM*PAR(IX2)*PX2/IX2
      IF(IY2.NE.0)YW2=YW2+WLAM*PAR(IY2)*PY2/IY2
      IF(IZ2.NE.0)XZW2=XZW2+WLAM*PAR(IZ2)*PZ2/IZ2
      IF(IOUT.EQ.0)WRITE(26,430)GM,ITG,NS,XW1,YW1,XZW1,
     & XW2,YW2,XZW2,RAD
      XW1= XW1* TA
      YW1= YW1* TA
      XZW1= XZW1* TA
      CALL MOVE(XW1,YW1,XZW1,XW2,YW2,XZW2,INT(RAD+.5),NS,ITG)
      GOTO 1
 2210 IF(NNPAR.LT.IX1)NNPAR=IX1
      IF(NNPAR.LT.IY1)NNPAR=IY1
      IF(NNPAR.LT.IZ1)NNPAR=IZ1
      IF(NNPAR.LT.IX2)NNPAR=IX2
      IF(NNPAR.LT.IY2)NNPAR=IY2
      IF(NNPAR.LT.IZ2)NNPAR=IZ2
      IF(NNPAR.LT.IRD)NNPAR=IRD
      GOTO 2230




C *GH* Generate helix
  123 NWIRE= NWIRE+1
      I1= N+1
      I2= N+ NS
      WRITE(*,124)  XW1, YW1, NWIRE,XZW1,XW2,YW2,XZW2,RAD,NS,I1,
     &I2, ITG
  124 FORMAT(' **HELIX**  AXIAL SPACING BETWEEN TURNS =',
     &F8.3,' TOTAL LENGTH =',F8.3/1X,I3,2X,'RADII:',
     &4F10.3,7X,F6.2,I4,I4,I4,I3)
      CALL HELIX( XW1, YW1, XZW1,XW2,YW2, XZW2, RAD, NS, ITG)
      GOTO 1
C


C *GX* Refelct structure along x,y and z axis.
   18 CONTINUE
      IF(IOUT.EQ.0)WRITE(26,430)GM,ITG,NS,XW1,YW1,XZW1,
     & XW2,YW2,XZW2,RAD
      IY= NS/10
      IZ= NS- IY*10
      IX= IY/10
      IY= IY- IX*10
      IF( IX.NE.0) IX=1
      IF( IY.NE.0) IY=1
      IF( IZ.NE.0) IZ=1
C     WRITE(*,44)  IFX( IX+1), IFY( IY+1), IFZ( IZ+1), ITG
   44 FORMAT(6X,'STRUCTURE REFLECTED ALONG THE AXES',3(1X,A1),
     &'.  TAGS INCREMENTED BY',I5)
      GOTO 20

C *GR* Rotate about z-axis.
   19 WRITE(*,45)  NS, ITG
   45 FORMAT(6X,'STRUCTURE ROTATED ABOUT Z-AXIS',I3,' TIMES.  LABELS',
     &' INCREMENTED BY',I5)
      IX=-1
   20 CALL REFLC( IX, IY, IZ, ITG, NS)
      GOTO 1

C *GS* Scale structure by XW1
   21 CONTINUE
      IF(IOUT.EQ.0)WRITE(26,431)GM,ITG,NS,XW1,YW1,XZW1,
     & XW2,YW2,XZW2,RAD
 431  FORMAT(A2,I3,I5,F10.6,5F10.3,F9.3)
      IF(GSVAL.EQ.XW1)GOTO 5537
      WRITE(*,*)'GS NOT SAME IN INPUT.NEC AND PARNR.NEC'
      STOP
 5537 CONTINUE
      DO 22  I= 1, N
      X( I)= X( I)* XW1
      Y( I)= Y( I)* XW1
      RXZ( I)= RXZ( I)* XW1
      X2( I)= X2( I)* XW1
      Y2( I)= Y2( I)* XW1
      XZ2( I)= XZ2( I)* XW1
      BI0(I)=BI0(I)*XW1
   22 BI( I)= BI( I)* XW1
      GOTO 1
C
C
C *GE* End of geometry
  29  CONTINUE
      IF(IOUT.EQ.0)WRITE(26,430)GM,ITG,NS,XW1,YW1,XZW1,
     & XW2,YW2,XZW2,RAD
      IF(ITG.EQ.0)GOTO 290
      WRITE(*,*)'*GE* No ground plane allowed'
      STOP
 290  CONTINUE
      IF(NGEOM.NE.0)GOTO 2311
      OPEN ( UNIT=10,FILE='GEOMETRY.NEC')
      WRITE(10,52)
   52 FORMAT(//' Segment and surface patch data for latest run',
     &/,' Data is input from file INPUT.NEC',//)
 2311 CALL CONECT
      IF( N.LE.NM) GOTO 37
      WRITE(*,*)' TOO MANY SEGMENTS'
      STOP
   37 CONTINUE
      IF( N.EQ.0) GOTO 33
      IF(NGEOM.NE.0)GOTO 2322
      WRITE(10,53)
   53 FORMAT(//,' WIRE SEGMENTS,  COORDINATES IN METERS')
      WRITE(10,*)'I+ AND I- INDICATE THE SEGMENTS BEFORE AND AFTER I'
      WRITE(10,54)
   54 FORMAT(' SEG  COORD. FOR CENTER',8X,'SEG',9X,
     &'ANGLES',6X,'WIRE',5X,'CONNECT',4X,'TAG',/,2X
     &,'NO',5X,'X',7X,'Y',7X,'Z',4X,'LENGTH',4X,'ALPHA',3X,'BETA',3X,
     &'RADIUS',2X,'I-',3X,'I',2X,'I+',3X,'NO')
 2322 DO 32  I=1, N
      XW1= X2( I)- X( I)
      YW1= Y2( I)- Y( I)
      XZW1= XZ2( I)- RXZ( I)
      X( I)=( X( I)+ X2( I))*.5
      Y( I)=( Y( I)+ Y2( I))*.5
      RXZ( I)=( RXZ( I)+ XZ2( I))*.5
      XW2= XW1* XW1+ YW1* YW1+ XZW1* XZW1
      YW2= SQRT( XW2)
      YW2=( XW2/ YW2+ YW2)*.5
      SI( I)= YW2
      CAB( I)= XW1/ YW2
      SAB( I)= YW1/ YW2
      XW2= XZW1/ YW2
      IF( XW2.GT.1.) XW2=1.
      IF( XW2.LT.-1.) XW2=-1.
      SALP( I)= XW2
      XW2= ASIN( XW2)* TD
      YW2= ATGN2( YW1, XW1)* TD
      IF(NGEOM.EQ.0)WRITE(10,55)I,X(I),Y(I),RXZ(I),SI(I),XW2,YW2,
     & BI(I),ICON1(I),I,ICON2(I),ITAG(I)
   55 FORMAT(I4,3F8.3,F8.4,1X,2F8.3,F8.6,3I4,I5)
      IF( SI( I).GT.1.D-20.AND. BI( I).GT.0.) GOTO 32
      WRITE(*,56)
      WRITE(10,56)
   56 FORMAT(' SEGMENT DATA ERROR')
      WRITE(*,*)'See file GEOMETRY.NEC'
      STOP
   32 CONTINUE
   33 RETURN
      END
