      SUBROUTINE NETWK( ZCM, IP, EINC)
C     SUBROUTINE NETWK SOLVES FOR STRUCTURE CURRENTS FOR A GIVEN
C     EXCITATION INCLUDING THE EFFECT OF NON-RADIATING NETWORKS IF
C     PRESENT.
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      COMPLEX*16  CMN, RHNT, YMIT, RHS, EINC, VLT,
     &VSRC, RHNX,  CUX
      INCLUDE 'data.inc'
      INCLUDE 'vsorc.inc'
      INCLUDE 'cntrl.inc'
      INCLUDE 'crnt.inc'
      INCLUDE 'netcx.inc'
      DIMENSION EINC(1), IP(1), ZCM(1)
      DIMENSION CMN(NETMX,NETMX),RHNT(NETMX),IPNT(NETMX),NTEQA(NETMX),
     &NTSCA(NETMX), RHS( NM), VSRC(NVMAX), RHNX(NETMX)
      PARAMETER (NDIMNP=NETMX+1)
      DATA   PI/3.141592653589793D0/


      TP=2*PI
      PIN=0.
      PNLS=0.
C
C     SOLUTION OF NETWORK EQUATIONS
   14 IF( NONET.EQ.0) GOTO 48
      DO 15  I=1, NETMX
      RHNX( I)=(0.,0.)
      DO 15  J=1, NETMX
   15 CMN( I, J)=(0.,0.)
      NTEQ=0
C
C     SORT NETWORK AND SOURCE DATA AND ASSIGN EQUATION NUMBERS TO
C     SEGMENTS.
C
      NTSC=0
      DO 38  J=1, NONET
      NSEG1= ISEG1( J)
      NSEG2= ISEG2( J)
      IF( NTYP( J).GT.1) GOTO 16
      Y11R= X11R( J)
      Y11I= X11I( J)
      Y12R= X12R( J)
      Y12I= X12I( J)
      Y22R= X22R( J)
      Y22I= X22I( J)
      GOTO 17
   16 Y22R= TP* X11I( J)/ WLAM
      Y12R=0.
      Y12I=1./( X11R( J)* SIN( Y22R))
      Y11R= X12R( J)
      Y11I=- Y12I* COS( Y22R)
      Y22R= X22R( J)
      Y22I= Y11I+ X22I( J)
      Y11I= Y11I+ X12I( J)
      IF( NTYP( J).EQ.2) GOTO 17
      Y12R=- Y12R
      Y12I=- Y12I
   17 IF( NSANT.EQ.0) GOTO 19
      DO 18  I=1, NSANT
      IF( NSEG1.NE. ISANT( I)) GOTO 18
      ISC1= I
      GOTO 22
   18 CONTINUE
   19 ISC1=0
      IF( NTEQ.EQ.0) GOTO 21
      DO 20  I=1, NTEQ
      IF( NSEG1.NE. NTEQA( I)) GOTO 20
      IROW1= I
      GOTO 25
   20 CONTINUE
   21 NTEQ= NTEQ+1
      IROW1= NTEQ
      NTEQA( NTEQ)= NSEG1
      GOTO 25
   22 IF( NTSC.EQ.0) GOTO 24
      DO 23  I=1, NTSC
      IF( NSEG1.NE. NTSCA( I)) GOTO 23
      IROW1= NDIMNP- I
      GOTO 25
   23 CONTINUE
   24 NTSC= NTSC+1
      IROW1= NDIMNP- NTSC
      NTSCA( NTSC)= NSEG1
      VSRC( NTSC)= ZVSNT( ISC1)
   25 IF( NSANT.EQ.0) GOTO 27
      DO 26  I=1, NSANT
      IF( NSEG2.NE.ISANT( I)) GOTO 26
      ISC2= I
      GOTO 30
   26 CONTINUE
   27 ISC2=0
      IF( NTEQ.EQ.0) GOTO 29
      DO 28  I=1, NTEQ
      IF( NSEG2.NE. NTEQA( I)) GOTO 28
      IROW2= I
      GOTO 33
   28 CONTINUE
   29 NTEQ= NTEQ+1
      IROW2= NTEQ
      NTEQA( NTEQ)= NSEG2
      GOTO 33
   30 IF( NTSC.EQ.0) GOTO 32
      DO 31  I=1, NTSC
      IF( NSEG2.NE. NTSCA( I)) GOTO 31
      IROW2= NDIMNP- I
      GOTO 33
   31 CONTINUE
   32 NTSC= NTSC+1
      IROW2= NDIMNP- NTSC
      NTSCA( NTSC)= NSEG2
      VSRC( NTSC)= ZVSNT( ISC2)
   33 IF( NTSC+ NTEQ.LT. NDIMNP) GOTO 34
      WRITE(*,59)
C
C     FILL NETWORK EQUATION MATRIX AND RIGHT HAND SIDE VECTOR WITH
C     NETWORK SHORT-CIRCUIT ADMITTANCE MATRIX COEFFICIENTS.
C
      STOP
   34 IF( ISC1.NE.0) GOTO 35
      CMN( IROW1, IROW1)= CMN( IROW1, IROW1)- CMPLX( Y11R, Y11I)* SI(
     &NSEG1)
      CMN( IROW1, IROW2)= CMN( IROW1, IROW2)- CMPLX( Y12R, Y12I)* SI(
     &NSEG1)
      GOTO 36
   35 RHNX( IROW1)= RHNX( IROW1)+ CMPLX( Y11R, Y11I)* ZVSNT( ISC1)/
     &WLAM
      RHNX( IROW2)= RHNX( IROW2)+ CMPLX( Y12R, Y12I)* ZVSNT( ISC1)/
     &WLAM
   36 IF( ISC2.NE.0) GOTO 37
      CMN( IROW2, IROW2)= CMN( IROW2, IROW2)- CMPLX( Y22R, Y22I)* SI(
     &NSEG2)
      CMN( IROW2, IROW1)= CMN( IROW2, IROW1)- CMPLX( Y12R, Y12I)* SI(
     &NSEG2)
      GOTO 38
   37 RHNX( IROW1)= RHNX( IROW1)+ CMPLX( Y12R, Y12I)* ZVSNT( ISC2)/
     &WLAM
      RHNX( IROW2)= RHNX( IROW2)+ CMPLX( Y22R, Y22I)* ZVSNT( ISC2)/
     &WLAM
C
C     ADD INTERACTION MATRIX ADMITTANCE ELEMENTS TO NETWORK EQUATION
C     MATRIX
C
   38 CONTINUE
      DO 41  I=1, NTEQ
      DO 39  J=1, N
   39 RHS( J)=(0.,0.)
      IROW1= NTEQA( I)
      RHS( IROW1)=(1.,0.)
      CALL SOLGF(ZCM,RHS,IP,NP,N)
      CALL CABC( RHS)
      DO 40  J=1, NTEQ
      IROW1= NTEQA( J)
   40 CMN( I, J)= CMN( I, J)+ RHS( IROW1)
C
C     FACTOR NETWORK EQUATION MATRIX
C
   41 CONTINUE
C
C     ADD TO NETWORK EQUATION RIGHT HAND SIDE THE TERMS DUE TO ELEMENT
C     INTERACTIONS
C
      CALL FACTR( NTEQ, CMN, IPNT, NETMX)
   42 IF( NONET.EQ.0) GOTO 48
      DO 43  I=1, N
   43 RHS( I)= EINC( I)
      CALL SOLGF(ZCM,RHS,IP,NP,N)
      CALL CABC( RHS)
      DO 44  I=1, NTEQ
      IROW1= NTEQA( I)
C
C     SOLVE NETWORK EQUATIONS
C
   44 RHNT( I)= RHNX( I)+ RHS( IROW1)
C
C     ADD FIELDS DUE TO NETWORK VOLTAGES TO ELECTRIC FIELDS APPLIED TO
C     STRUCTURE AND SOLVE FOR INDUCED CURRENT
C
      CALL SOLVE( NTEQ, CMN, IPNT, RHNT, NETMX)
      DO 45  I=1, NTEQ
      IROW1= NTEQA( I)
   45 EINC( IROW1)= EINC( IROW1)- RHNT( I)
      CALL SOLGF(ZCM,EINC,IP,NP,N)
      CALL CABC( EINC)
      IF( NGEOM.EQ.0) WRITE(10,61)
      IF( NGEOM.EQ.0) WRITE(10,60)
      DO 46  I=1, NTEQ
      IROW1= NTEQA( I)
      VLT= RHNT( I)* SI( IROW1)* WLAM
      CUX= EINC( IROW1)* WLAM
      YMIT= CUX/ VLT
      ZPED= VLT/ CUX
      IROW2= ITAG( IROW1)
      PWR=.5* DBLE( VLT* CONJG( CUX))
      PNLS= PNLS- PWR
      DO 6624 J=1,NZTNOM
      IF(IZTNOM(J).NE.IROW1)GOTO 6624
      ZRNT(J)=ZPED
 6624 CONTINUE
   46 IF(NGEOM.EQ.0)WRITE(10,62)IROW2,IROW1,VLT,CUX,ZPED,YMIT,PWR
      IF( NTSC.EQ.0) GOTO 49
      DO 47  I=1, NTSC
      IROW1= NTSCA( I)
      VLT= VSRC( I)
      CUX= EINC( IROW1)* WLAM
      YMIT= CUX/ VLT
      ZPED= VLT/ CUX
      IROW2= ITAG( IROW1)
      PWR=.5* DBLE( VLT* CONJG( CUX))
      PNLS= PNLS- PWR
      DO 6625 J=1,NZTNOM
      IF(IZTNOM(J).NE.IROW1)GOTO 6625
      ZRNT(J)=ZPED
 6625 CONTINUE
   47 IF(NGEOM.EQ.0)WRITE(10,62)IROW2,IROW1,VLT,CUX,ZPED,YMIT,PWR
C
C     SOLVE FOR CURRENTS WHEN NO NETWORKS ARE PRESENT
C
      GOTO 49
   48 CALL SOLGF(ZCM,EINC,IP,NP,N)
      CALL CABC( EINC)
   49 CONTINUE
      IF( NSANT.EQ.0) GOTO 56
      DO 55  I=1, NSANT
      ISC1= ISANT( I)
      VLT= ZVSNT( I)
      CUX= EINC( ISC1)* WLAM
      ZRVS(I)= VLT/ CUX
      PWR=.5* DBLE( VLT* CONJG( CUX))
      PIN= PIN+ PWR
   55 CONTINUE

   56 IF( NVQD.EQ.0) RETURN
      DO 57  I=1, NVQD
      ISC1= IVQD( I)
      VLT= ZVQD( I)
      CUX= CMPLX( AIR( ISC1), AII( ISC1))
      YMIT= CMPLX( BIR( ISC1), BII( ISC1))
      ZPED= CMPLX( CIR( ISC1), CII( ISC1))
      PWR= SI( ISC1)* TP*.5
      CUX=( CUX- YMIT* SIN( PWR)+ ZPED* COS( PWR))* WLAM
      YMIT= CUX/ VLT
      ZRVQ(I)= VLT/ CUX
      PWR=.5* DBLE( VLT* CONJG( CUX))
      PIN= PIN+ PWR
   57 CONTINUE
C
      RETURN
   59 FORMAT(1X,'ERROR - - NETWORK ARRAY DIMENSIONS TOO SMALL')
   60 FORMAT(/,3X,'TAG',3X,'SEG.',4X,'VOLTAGE (VOLTS)',9X,'CURRENT (',
     &'AMPS)',9X,'IMPEDANCE (OHMS)',8X,'ADMITTANCE (MHOS)',6X,'POWER',/
     &,3X,'NO.',3X,'NO.',4X,'REAL',8X,'IMAG.',3(7X,'REAL',8X,'IMAG.'),5
     &X,'(WATTS)')
   61 FORMAT(///,27X,'- - - STRUCTURE EXCITATION DATA AT NETWORK CONN',
     &'ECTION POINTS - - -')
   62 FORMAT(2(1X,I5),1P,9E12.5)
      END
