      SUBROUTINE REFLC( IX, IY, IZ, ITX, NOP)
C     REFLC REFLECTS PARTIAL STRUCTURE ALONG X,Y, OR Z AXES OR ROTATES
C     STRUCTURE TO COMPLETE A SYMMETRIC STRUCTURE.
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      COMMON  /ANGL/ SALP( NM)
      DIMENSION X2(NM),Y2(NM),XZ2(NM)
      EQUIVALENCE(X2(1),SI(1)),(Y2(1),ALP(1)),(XZ2(1),BET(1))
      EQUIVALENCE(T1X,SI),(T1Y,ALP),(T1Z,BET),(T2X,ICON1),(T2Y,ICON2),(
     &T2Z,ITAG)
      DATA   PI/3.141592653589793D0/
      NP= N
      IPSYM=0
      ITI= ITX
      IF( IX.LT.0) GOTO 19
      IF( NOP.EQ.0) RETURN
      IPSYM=1
C
C     REFLECT ALONG Z AXIS
C
      IF( IZ.EQ.0) GOTO 3
      IPSYM=2
      DO 2  I= 1, N
      NX= I+ N
      IF(NX.GT.NM)GOTO 944
      E1= RXZ( I)
      E2= XZ2( I)
      IF( ABS( E1)+ ABS( E2).GT.1.D-5.AND. E1* E2.GE.-1.D-6) GOTO 1
      WRITE( 6,24)  I
      STOP
    1 X( NX)= X( I)
      Y( NX)= Y( I)
      RXZ( NX)=- E1
      X2( NX)= X2( I)
      Y2( NX)= Y2( I)
      XZ2( NX)=- E2
      ITAGI= ITAG( I)
      IF( ITAGI.EQ.0) ITAG( NX)=0
      IF( ITAGI.NE.0) ITAG( NX)= ITAGI+ ITI
      BI0(NX)=BI0(I)
    2 BI( NX)= BI( I)
      N= N*2
      ITI= ITI*2
C
C     REFLECT ALONG Y AXIS
C
    3 IF( IY.EQ.0) GOTO 9
      DO 8  I= 1, N
      NX= I+ N
      IF(NX.GT.NM)GOTO 944
      E1= Y( I)
      E2= Y2( I)
      IF( ABS( E1)+ ABS( E2).GT.1.D-5.AND. E1* E2.GE.-1.D-6) GOTO 7
      WRITE( 6,24)  I
      STOP
    7 X( NX)= X( I)
      Y( NX)=- E1
      RXZ( NX)= RXZ( I)
      X2( NX)= X2( I)
      Y2( NX)=- E2
      XZ2( NX)= XZ2( I)
      ITAGI= ITAG( I)
      IF( ITAGI.EQ.0) ITAG( NX)=0
      IF( ITAGI.NE.0) ITAG( NX)= ITAGI+ ITI
      BI0(NX)=BI0(I)
    8 BI( NX)= BI( I)
      N= N*2
      ITI= ITI*2
C
C     REFLECT ALONG X AXIS
C
    9 IF( IX.EQ.0) GOTO 15
      DO 14  I= 1, N
      NX= I+ N
      IF(NX.GT.NM)GOTO 944
      E1= X( I)
      E2= X2( I)
      IF( ABS( E1)+ ABS( E2).GT.1.D-5.AND. E1* E2.GE.-1.D-6) GOTO 13
      WRITE( 6,24)  I
      STOP
   13 X( NX)=- E1
      Y( NX)= Y( I)
      RXZ( NX)= RXZ( I)
      X2( NX)=- E2
      Y2( NX)= Y2( I)
      XZ2( NX)= XZ2( I)
      ITAGI= ITAG( I)
      IF( ITAGI.EQ.0) ITAG( NX)=0
      IF( ITAGI.NE.0) ITAG( NX)= ITAGI+ ITI
      BI0(NX)=BI0(I)
   14 BI( NX)= BI( I)
      N= N*2
   15 RETURN
C
C     REPRODUCE STRUCTURE WITH ROTATION TO FORM CYLINDRICAL STRUCTURE
C
   19 FNOP= NOP
      IPSYM=-1
      SAM=2*PI/ FNOP
      CS= COS( SAM)
      SS= SIN( SAM)
      N=  N * NOP
      NX= NP+1
      IF(N.GT.NM)GOTO 944
      DO 20  I= NX, N
      K= I- NP
      XK= X( K)
      YK= Y( K)
      IF(I.GT.NM)GOTO 944
      X( I)= XK* CS- YK* SS
      Y( I)= XK* SS+ YK* CS
      RXZ( I)= RXZ( K)
      XK= X2( K)
      YK= Y2( K)
      X2( I)= XK* CS- YK* SS
      Y2( I)= XK* SS+ YK* CS
      XZ2( I)= XZ2( K)
      ITAGI= ITAG( K)
      IF( ITAGI.EQ.0) ITAG( I)=0
      IF( ITAGI.NE.0) ITAG( I)= ITAGI+ ITI
      BI0(I)=BI0(K)
   20 BI( I)= BI( K)
   21 RETURN
   24 FORMAT(' GEOMETRY DATA ERROR--SEGMENT,I5,26H LIES IN PLANE OF S',
     &'YMMETRY')
   25 FORMAT(' GEOMETRY DATA ERROR--PATCH,I4,26H LIES IN PLANE OF SYM',
     &'METRY')
 944  WRITE(*,*)'TOO MANY SEGMENTS - SYMMETRY OP.'
      STOP
      END
