      SUBROUTINE SOLVE( N, ZA, IP, ZB, NDIM)
C     SUBROUTINE TO SOLVE THE MATRIX EQUATION LU*X=ZB WHERE L IS A UNIT
C     LOWER TRIANGULAR MATRIX AND U IS AN UPPER TRIANGULAR MATRIX BOTH
C     OF WHICH ARE STORED IN ZA.  THE RHS VECTOR ZB IS INPUT AND THE
C     SOLUTION IS RETURNED THROUGH VECTOR ZB.    (MATRIX TRANSPOSED.
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INTEGER  PI
      COMMON  /SCRATM/ ZY(NM)
C
C     FORWARD SUBSTITUTION
C
      DIMENSION  ZA( NDIM, NDIM), IP( NDIM), ZB( NDIM)
      DO 3  I=1, N
      PI= IP( I)
      ZY( I)= ZB( PI)
      ZB( PI)= ZB( I)
      IP1= I+1
      IF( IP1.GT. N) GOTO 2
      DO 1  J= IP1, N
      ZB( J)= ZB( J)- ZA( I, J)* ZY( I)
    1 CONTINUE
    2 CONTINUE
C
C     BACKWARD SUBSTITUTION
C
    3 CONTINUE
      DO 6  K=1, N
      I= N- K+1
      ZSUM=(0.,0.)
      IP1= I+1
      IF( IP1.GT. N) GOTO 5
      DO 4  J= IP1, N
      ZSUM= ZSUM+ ZA( J, I)* ZB( J)
    4 CONTINUE
    5 CONTINUE
      ZB( I)=( ZY( I)- ZSUM)/ ZA( I, I)
    6 CONTINUE
      RETURN
      END
