      FUNCTION ZINT( SIGL, ROLAM)
C     ZINT COMPUTES THE INTERNAL IMPEDANCE OF A CIRCULAR WIRE
C
      INCLUDE 'prec.inc'
      DIMENSION  FJX(2), CNX(2), CCN(28)
      EQUIVALENCE (ZFJ,FJX),(ZCN,CNX),(ZCC1,CCN(1)),(ZCC2,CCN(3))
      EQUIVALENCE (ZCC3,CCN(5)),(ZCC4,CCN(7)),(ZCC5,CCN(9))
      EQUIVALENCE (ZCC7,CCN(13)),(ZCC8,CCN(15)),(ZCC9,CCN(17))
      EQUIVALENCE (ZCC10,CCN(19)),(ZCC11,CCN(21)),(ZCC12,CCN(23))
      EQUIVALENCE (ZCC13,CCN(25)),(ZCC14,CCN(27)),(ZCC6,CCN(11))
      DATA   PI/3.141592653589793D0/
      DATA POT,TPCMU/1.5707963D+0,2.368705D+3/
      DATA   CMOTP/60.00/, FJX/0.,1./, CNX/.70710678D+0,.70710678D+0/
      DATA   CCN/6.D-7,1.9D-6,-3.4D-6,5.1D-6,-2.52D-5,0.,-9.06D-5,-
     &9.01D-5,0.,-9.765D-4,.0110486D+0,-.0110485D+0,0.,-.3926991D+0,
     &1.6D-6,-3.2D-6,1.17D-5,-2.4D-6,3.46D-5,3.38D-5,5.D-7,2.452D-4,-
     &1.3813D-3,1.3811D-3,-6.25001D-2,-1.D-7,.7071068D+0,.7071068D+0/
      ZTH(CCD)=(((((ZCC1*CCD+ZCC2)*CCD+ZCC3)*CCD+
     & ZCC4)*CCD+ZCC5)*CCD+ ZCC6)*CCD+ ZCC7
      ZPH(CCD)=(((((ZCC8*CCD+ZCC9)*CCD+ZCC10)*CCD+
     & ZCC11)*CCD+ZCC12)*CCD+ ZCC13)*CCD+ ZCC14
      ZF( CCD)= SQRT( POT/CCD)* EXP(- ZCN*CCD+ ZTH(-8./ X))
      ZG(CCD)= EXP( ZCN*CCD+ ZTH(8./ X))/ SQRT( 2*PI*CCD)
      X= SQRT( TPCMU* SIGL)* ROLAM
      IF( X.GT.110.) GOTO 2
      IF( X.GT.8.) GOTO 1
      Y= X/8.
      Y= Y* Y
      S= Y* Y
      BER=((((((-9.01D-6* S+1.22552D-3)* S-.08349609D+0)* S+
     &2.6419140D+0)* S-32.363456D+0)* S+113.77778D+0)* S-64.)* S+1.
      BEI=((((((1.1346D-4* S-.01103667D+0)* S+.52185615D+0)* S-
     &10.567658D+0)* S+72.817777D+0)* S-113.77778D+0)* S+16.)* Y
      ZBR1= CMPLX( BER, BEI)
      BER=(((((((-3.94D-6* S+4.5957D-4)* S-.02609253D+0)* S+
     &.66047849D+0)* S-6.0681481D+0)* S+14.222222D+0)* S-4.)* Y)* X
      BEI=((((((4.609D-5* S-3.79386D-3)* S+.14677204D+0)* S-
     &2.3116751D+0)* S+11.377778D+0)* S-10.666667D+0)* S+.5)* X
      ZBR2= CMPLX( BER, BEI)
      ZBR1= ZBR1/ ZBR2
      GOTO 3
    1 ZBR2= ZFJ* ZF( X)/ PI
      ZBR1= ZG( X)+ ZBR2
      ZBR2= ZG( X)* ZPH(8./ X)- ZBR2* ZPH(-8./ X)
      ZBR1= ZBR1/ ZBR2
      GOTO 3
    2 ZBR1= CMPLX(.70710678D+0,-.70710678D+0)
    3 ZINT= ZFJ* SQRT( CMOTP/ SIGL)* ZBR1/ ROLAM
      RETURN
      END
